
package org.postgresql.jdbc2;

import java.math.BigDecimal;
import java.util.Calendar;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.SQLWarning;

import java.sql.Blob;
import java.sql.ResultSetMetaData;
import java.sql.Array;
import java.sql.Clob;
import java.sql.Ref;
import java.sql.PreparedStatement;
import java.sql.CallableStatement;
	
public class WrappedCallableStatement extends WrappedPreparedStatement implements CallableStatement {
    
    
    private CallableStatement cs;
    public WrappedCallableStatement(CallableStatement stmt, PostgresqlPooledConnection ppc){
        super(stmt,ppc);
        this.cs = stmt;
    }

    public void registerOutParameter(int parameterIndex, int sqlType) throws SQLException{
        try{
            cs.registerOutParameter( parameterIndex,  sqlType);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }

    
    public void registerOutParameter(int parameterIndex, int sqlType, int scale) throws SQLException{
        try{
            cs.registerOutParameter( parameterIndex,  sqlType, scale);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }

    
    public boolean wasNull() throws SQLException{
        try{
            return cs.wasNull();
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }
    
	
	public String getString(int parameterIndex) throws SQLException{
        try{
            return cs.getString( parameterIndex);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }
    
	
	public boolean getBoolean(int parameterIndex) throws SQLException{
        try{
            return cs.getBoolean( parameterIndex);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }

	
	public byte getByte(int parameterIndex) throws SQLException{
        try{
            return cs.getByte( parameterIndex);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }

	
	public short getShort(int parameterIndex) throws SQLException{
        try{
            return cs.getShort( parameterIndex);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }

	
	public int getInt(int parameterIndex) throws SQLException{
        try{
            return cs.getInt( parameterIndex);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }

	
	public long getLong(int parameterIndex) throws SQLException{
        try{
            return cs.getLong( parameterIndex);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }

	
	public float getFloat(int parameterIndex) throws SQLException{
        try{
            return cs.getFloat( parameterIndex);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }
    
	
    public double getDouble(int parameterIndex) throws SQLException{
        try{
            return cs.getDouble( parameterIndex);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }
    
		
    public BigDecimal getBigDecimal(int parameterIndex, int scale)  throws SQLException{
        try{
            return cs.getBigDecimal( parameterIndex,  scale);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }

		
    public byte[] getBytes(int parameterIndex) throws SQLException{
        try{
            return cs.getBytes( parameterIndex);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }

		
    public java.sql.Date getDate(int parameterIndex) throws SQLException{
        try{
            return cs.getDate( parameterIndex);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }

		
    public java.sql.Time getTime(int parameterIndex) throws SQLException{
        try{
            return cs.getTime( parameterIndex);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }

		
    public java.sql.Timestamp getTimestamp(int parameterIndex) throws SQLException{
        try{
            return cs.getTimestamp( parameterIndex);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }
    
    public Object getObject(int parameterIndex) throws SQLException{
        try{
            return cs.getObject( parameterIndex);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }


    public BigDecimal getBigDecimal(int parameterIndex) throws SQLException{
        try{
            return cs.getBigDecimal( parameterIndex);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }

		
    public Object  getObject (int i, java.util.Map map) throws SQLException{
        try{
            return cs. getObject ( i,  map);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }
    
		
    public Ref getRef (int i) throws SQLException{
        try{
            return cs.getRef ( i);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }
    
		
    public Blob getBlob (int i) throws SQLException{
        try{
            return cs.getBlob ( i);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }
    
		
    public Clob getClob (int i) throws SQLException{
        try{
            return cs.getClob ( i);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }
    
    
    public Array getArray (int i) throws SQLException{
        try{
            return cs.getArray ( i);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }
    
    
    public java.sql.Date getDate(int parameterIndex, Calendar cal)  throws SQLException{
        try{
            return cs.getDate( parameterIndex,  cal);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }

		
    public java.sql.Time getTime(int parameterIndex, Calendar cal)  throws SQLException{
        try{
            return cs.getTime( parameterIndex,  cal);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }
    
		
    public java.sql.Timestamp getTimestamp(int parameterIndex, Calendar cal) throws SQLException{
        try{
            return cs.getTimestamp( parameterIndex,  cal);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }

    public void registerOutParameter (int paramIndex, int sqlType, String typeName) throws SQLException{
        try{
            cs.registerOutParameter ( paramIndex,  sqlType,  typeName);
        }catch(SQLException e){
            ppc.setException(e);
            throw(e);
        }
    }
}




